﻿using App.VolgaIt.Dto;
using Infrastructure.VolgaIt;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace App.VolgaIt.Services
{
    public class UserService
    {
        private UnitOfWork _uow;

        public UserService(UnitOfWork uow)
        {
            _uow = uow;
        }

        public async Task EditUserNameAsync(EditNameDto dto)
        {
            var user = await _uow.UserRepo.FindEntityByAsync(x => x.Login == dto.OldName);
            if (user == null)
                throw new Exception("пользователь не найден");

            if (string.IsNullOrEmpty(dto.NewName))
                throw new Exception("новое имя не корректно");

            user.Login = dto.NewName;

            await _uow.SaveChangesAsync();
        }

        public async Task RemoveUserByName(string userName)
        {
            var user = await _uow.UserRepo.FindEntityByAsync(x => x.Login == userName);
            if (user is null)
                throw new Exception("пользователь не найден");

            _uow.UserRepo.RemoveEntity(user);
            await _uow.SaveChangesAsync();
        }
    }
}
