﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace Domain.VolgaIt.Interfaces
{
    public interface IRepository<TEntity> where TEntity : class
    {
        void AddEntity(TEntity entity);
        void RemoveEntity(TEntity entity);
        void UpdateEntity(TEntity entity);
        Task<List<TEntity>> GetAllEntitiesAsync();
        Task<List<TEntity>> FindEntitiesByAsync(Expression<Func<TEntity, bool>> filter);
        Task<TEntity> FindEntityByIdAsync(string entityId);
        Task<TEntity> FindEntityByAsync(Expression<Func<TEntity, bool>> filter);
    }
}
