﻿using Domain.VolgaIt.Entities;
using Infrastructure.VolgaIt.Context;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace Infrastructure.VolgaIt.Repositories
{
    public class AdCategoryRepository : BaseRepository<AdCategory>
    {
        private VolgaContext _context;
        public AdCategoryRepository(VolgaContext context) : base(context)
        {
            _context = context;
        }

        public override async Task<AdCategory> FindEntityByAsync(Expression<Func<AdCategory, bool>> filter)
        {
            return await _context.AdCategories.Include(x => x.SubCategories).FirstOrDefaultAsync(filter);
        }
    }
}
