﻿using Infrastructure.VolgaIt.Context;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Domain.VolgaIt.Entities;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using System.Linq.Expressions;

namespace Infrastructure.VolgaIt.Repositories
{
    public class UserRepository : BaseRepository<User>
    {
        private VolgaContext _context;

        public UserRepository(VolgaContext context) : base(context)
        {
            _context = context;
        }

        public override async Task<User> FindEntityByAsync(Expression<Func<User, bool>> filter)
        {
            return await _context.Users
                .Include(x => x.UserAds)
                    .ThenInclude(x => x.Category)
                .Include(x => x.UserAds)
                    .ThenInclude(x => x.AdType)
                .Include(x => x.UserAds)
                    .ThenInclude(x => x.SubCategory)
                .Include(x => x.Role)

                .FirstOrDefaultAsync(filter);
        }
    }
}
