﻿using Domain.VolgaIt.Entities;
using Domain.VolgaIt.Interfaces;
using Infrastructure.VolgaIt.Context;
using Infrastructure.VolgaIt.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Infrastructure.VolgaIt
{
    public class UnitOfWork 
    {
        private VolgaContext _context;

        public UnitOfWork(VolgaContext context, UserRepository userRepo, UserRoleRepository userRoleRepo, 
            AdRepository adRepo, AdTypeRepository adTypeRepo, AdSubCategoryRepository adSubCtgRepo, AdCategoryRepository adCtgRepo)
        {
            _context = context;
            UserRepo = userRepo;
            UserRoleRepo = userRoleRepo;
            AdRepo = adRepo;
            AdTypeRepo = adTypeRepo;
            AdCtgRepo = adCtgRepo;
            AdSubCtgRepo = adSubCtgRepo;
        }

        public IRepository<User> UserRepo { get; set; }
        public IRepository<UserRole> UserRoleRepo { get; set; }
        public IRepository<Ad> AdRepo { get; set; }
        public IRepository<AdType> AdTypeRepo { get; set; }
        public IRepository<AdCategory> AdCtgRepo { get; set; }
        public IRepository<AdSubCategory> AdSubCtgRepo { get; set; }

        public async Task SaveChangesAsync()
        {
            await _context.SaveChangesAsync();
        }
    }
}
