﻿using Microsoft.AspNetCore.Http;
using System.IdentityModel.Tokens.Jwt;
using System.Linq;
using System.Net.Http.Headers;

namespace Web.VolgaIt.Helpers
{
    public static class HttpUserHelper
    {
        public static string GetLoginHttpUser(this HttpContext httpContext)
        {
            var token = httpContext.Request.Headers["authorization"];
            var tokenParam = AuthenticationHeaderValue.Parse(token).Parameter;

            var handler = new JwtSecurityTokenHandler();
            var tokenData = handler.ReadJwtToken(tokenParam);
            var userClaims = tokenData.Claims;

            return userClaims.FirstOrDefault(x => x.Type == "login").Value;
        }
    }
}
